#  Copyright (c) 1997-2010
#  Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
#  http://www.polymake.de
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation; either version 2, or (at your option) any
#  later version: http://www.gnu.org/licenses/gpl.txt.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#-------------------------------------------------------------------------------
#  $Project: polymake $$Id: utils.make 9891 2010-11-10 18:01:52Z gawrilow $

PERL ?= perl
_LocateBuildDir = $(shell $(if $(filter command, $(origin Arch)), Arch=${Arch}) ${PERL} -e '\
    do "${ProjectTop}/support/locate_build_dir"; \
    if ($$_=eval { (locate_build_dir($(if $(1),"$(1)")))[0] }) { print } else { print STDERR $$@ }')

MV := mv -f

# recursively expand a variable which may contain names of other variables
_expand_var = $(foreach word,$(1),$(if $(${word}),$(call _expand_var,$(${word})), ${word}))

# convert a space-separated list into a colon-separated path
_empty:=
_space:=${_empty} ${_empty}
_list2path = $(subst ${_space},:,$(strip $(1)))

# suffixes of C++ source files (not headers!)
CXX_suffixes := cc cpp C

# list all sources in a directory
_list_C_sources = $(patsubst $(1)/%,%,$(wildcard $(addprefix $(1)$(if $(2),/$(2))/*., c ${CXX_suffixes})))
_list_CXX_sources = $(patsubst $(1)/%,%,$(wildcard $(addprefix $(1)$(if $(2),/$(2))/*., ${CXX_suffixes})))

# list all subdirectories of the current directory
_list_dirs = $(shell $(if $(1),cd $(1) || exit 1;) for d in *; do [ -d $$d ] && echo $$d; done)

# convert a relative path to an absolute one
_abs_path = $(if $(filter /%,$(1)),$(1),$(shell ${PERL} -MCwd=abs_path -e 'print abs_path(q{$(1)})'))

# list all files or subdirectories marked with an SVN property
_get_no_export = $(if $(wildcard $(1)/.svn), \
		   $(shell svn propget $(if $(filter %/*,$(1)), noexport $(wildcard $(1)), -R noexport $(1)) | \
			   awk '$$3 ~ /$(2)/ { print $$1 }'))

override .svn := $(wildcard ${ProjectTop}/.svn)

# Local Variables:
# mode: Makefile
# End:
