<?xml version="1.0" encoding="utf-8"?>

<!--
$Id: macros.xsl 9871 2010-11-07 21:17:03Z gawrilow $

Common pieces of documentation processing stylesheets
-->

<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns="http://www.w3.org/1999/xhtml"
	xmlns:pm="http://www.polymake.de/ns/docs#3"
>

<xsl:variable name="version_text">
  <xsl:apply-templates mode="version" select="document('version.xml')/*"/>
</xsl:variable>

<xsl:template name="nav-box">
	<div class="nav">
		<div class="navheader">
			Navigation
		</div> 
		<div class="nav_inside">
			<ul class="nav">
				<li> <a href="index.html#apps">applications</a> </li>
				<li> <a href="core.html">core functionality</a></li>
				<li> <a href="doc_index.html">index</a> </li>
          <!-- FIXME: remove the condition as soon as the doxygen documentation ripens enough to be published without disgrace -->
          <xsl:choose>
            <xsl:when test="contains($version_text,'snapshot')">
				<li> <a href="PTL/index.html">PTL</a></li>
            </xsl:when>
          </xsl:choose>
				<li> <xsl:call-template name="wiki-ref"><xsl:with-param name="reftext">polymake wiki</xsl:with-param></xsl:call-template> </li>
          <xsl:choose>
            <xsl:when test="contains($version_text,'snapshot')">
				<li> <a href="http://polymake.mathematik.tu-darmstadt.de/release_docs/">release documentations</a></li>
            </xsl:when>
          </xsl:choose>
			</ul>  
		</div>  
	</div>
</xsl:template>

<xsl:template name="wiki-ref">
  <xsl:param name="reftext" />
  <xsl:element name="a">
    <xsl:attribute name="href">
      <xsl:value-of select="$Wiki"/>
    </xsl:attribute>
    <xsl:value-of select="$reftext" />
  </xsl:element>
</xsl:template>

<xsl:template mode="version" match="/pm:version">
  <xsl:apply-templates mode="version" select="*" /><xsl:if test="not(pm:extensions)">.</xsl:if>
</xsl:template>

<xsl:template mode="version" match="pm:revision">
  <xsl:text> extracted from svn snapshot </xsl:text> <xsl:value-of select="normalize-space(current())"/>
</xsl:template>

<xsl:template mode="version" match="pm:release">
  <xsl:text> as of release </xsl:text> <xsl:value-of select="normalize-space(current())"/>
</xsl:template>

<xsl:template mode="version" match="pm:extensions">
  <xsl:text> with the following individual extensions:</xsl:text>
  <ul class="ext">
    <xsl:for-each select="pm:extension">
      <li> <xsl:value-of select="current()" /> </li>
    </xsl:for-each>
  </ul>
</xsl:template>
  
</xsl:stylesheet>
